import { AfterContentInit, ChangeDetectorRef, ElementRef, NgZone, OnDestroy, OnInit, QueryList, Renderer2 } from '@angular/core';
import { NzUpdateHostClassService } from '../core/services/update-host-class.service';
import { NzSizeLDSType } from '../core/types/size';
import { NzWaveConfig, NzWaveDirective } from '../core/wave/nz-wave.directive';
export declare type NzButtonType = 'primary' | 'dashed' | 'danger';
export declare type NzButtonShape = 'circle' | null;
export declare class NzButtonComponent implements AfterContentInit, OnInit, OnDestroy {
    private elementRef;
    private cdr;
    private renderer;
    private nzUpdateHostClassService;
    private ngZone;
    private waveConfig;
    readonly el: HTMLElement;
    contentElement: ElementRef;
    listOfIconElement: QueryList<ElementRef>;
    nzWave: NzWaveDirective;
    nzBlock: boolean;
    nzGhost: boolean;
    nzSearch: boolean;
    nzType: NzButtonType;
    nzShape: NzButtonShape;
    nzSize: NzSizeLDSType;
    nzLoading: boolean;
    constructor(elementRef: ElementRef, cdr: ChangeDetectorRef, renderer: Renderer2, nzUpdateHostClassService: NzUpdateHostClassService, ngZone: NgZone, waveConfig: NzWaveConfig);
    private _ghost;
    private _search;
    private _type;
    private _shape;
    private _size;
    private _loading;
    private _block;
    private iconElement;
    private iconOnly;
    private prefixCls;
    private sizeMap;
    updateIconDisplay(value: boolean): void;
    /** temp solution since no method add classMap to host https://github.com/angular/angular/issues/7289 */
    setClassMap(): void;
    checkContent(): void;
    moveIcon(): void;
    ngAfterContentInit(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
